﻿using Microsoft.AspNetCore.Mvc;
using ModelBindingValidation.Models;

namespace ModelBindingValidation.Controllers
{
    public class HomeController : Controller
    {
        private IRepository repository;
        public HomeController(IRepository repo)
        {
            repository = repo;
        }
        public IActionResult Index(int id = 1)
        {
            return View(repository[id]);
        }

        public IActionResult Create() => View();

        [HttpPost]
        public IActionResult Create(Employee model) => View("Index", model);

        [HttpPost]
        public IActionResult DisplayPerson([Bind(Prefix = nameof(Employee.HomeAddress))] PersonAddress personAddress)
        {
            return View(personAddress);
        }

        public IActionResult Places(string[] places) => View(places);

        public IActionResult Address() => View();

        [HttpPost]
        public IActionResult Address(List<PersonAddress> address) => View(address);

        public IActionResult FromFormExample() => View();

        [HttpPost]
        public IActionResult FromFormExample([FromForm] Employee model)
        {
            ViewBag.Message = "Employee data received";
            return View();
        }

        /*[HttpPost]
        public Employee FromFormExample([FromForm] Employee model) => model;*/

        public IActionResult Body() => View();

        [HttpPost]
        public Employee Body([FromBody] Employee model) => model;

        public IActionResult FromRouteExample() => View();

        [HttpPost]
        public string FromRouteExample([FromRoute] string id) => id;

        public string Header([FromHeader] string accept) => $"Header: {accept}";

        public IActionResult FullHeader(FullHeader model) => View(model);
    }
}